'' BYVAL/BYREF speed test
''
'' compile with 'fbc passing.bas'
''  Sorry, windows only.

'' WARNING: serious #macro abuse below

#include once "counter.bas"

#macro DEFN_FUNC( by, t )
  sub func##by##t _
    ( _
      byval count as integer, _
      by arg0 as t, _
      by arg1 as t, _
      by arg2 as t, _
      by arg3 as t, _
      by arg4 as t, _
      by arg5 as t, _
      by arg6 as t, _
      by arg7 as t, _
      by arg8 as t, _
      by arg9 as t _
    )
    dim as t a0,a2,a1,a3,a4,a5,a6,a7,a8,a9
    dim as integer i
    for i = 1 to count
      a0=arg0
      a1=arg1
      a2=arg2
      a3=arg3
      a4=arg4
      a5=arg5
      a6=arg6
      a7=arg7
      a8=arg8
      a9=arg9
    next
  end sub
#endmacro

#macro DEFN_TYPE( t )
  DEFN_FUNC( BYVAL, t )
  DEFN_FUNC( BYREF, t )
#endmacro

#macro TEST_FUNC( count, by, t, c )
  scope
    dim as t a0,a2,a1,a3,a4,a5,a6,a7,a8,a9
    COUNTER_BEGIN( 1000, HIGH_PRIORITY_CLASS )
    func##by##t ( count,a0,a1,a2,a3,a4,a5,a6,a7,a8,a9 )
    COUNTER_END()
    c = COUNTER_CYCLES
  end scope
#endmacro

#macro TEST_TYPE( count, t )
  scope
    dim c1 as integer, c2 as integer
    print #t,
    TEST_FUNC( count, BYREF, t, c1 )
    TEST_FUNC( count, BYVAL, t, c2 )
    print c1,c2,100*(c1-c2)\c1 & "%"
  end scope
#endmacro

DEFN_TYPE( byte )
DEFN_TYPE( ubyte )
DEFN_TYPE( short )
DEFN_TYPE( ushort )
DEFN_TYPE( integer )
DEFN_TYPE( uinteger )
DEFN_TYPE( long )
DEFN_TYPE( ulong )
DEFN_TYPE( longint )
DEFN_TYPE( ulongint )
DEFN_TYPE( single )
DEFN_TYPE( double )

dim as integer i,N

for i = 0 to 2

  N = 100^i

  print "N = "; N
  print
  print "Type","BYREF","BYVAL","%"
  print "-------","--------","--------","--------"
  
  TEST_TYPE( N, byte )
  TEST_TYPE( N, ubyte )
  TEST_TYPE( N, short )
  TEST_TYPE( N, ushort )
  TEST_TYPE( N, integer )
  TEST_TYPE( N, uinteger )
  TEST_TYPE( N, long )
  TEST_TYPE( N, ulong )
  TEST_TYPE( N, longint )
  TEST_TYPE( N, ulongint )
  TEST_TYPE( N, single )
  TEST_TYPE( N, double )

  print
  print

next

